@if (vm$ | async; as vm) {
  <div [ngClass]="[jds.tablePaging]">
    <div [ngClass]="[jds.tableResponsive]">
      <table
        [ngClass]="[jds.table, jds.mb(0)]"
        role="table"
        aria-label="List Discontinue"
        aria-describedby="Table List Discontinue"
      >
        <thead>
          <tr>
            <th
              [style.width.%]="10"
              [colorScheme]="'gray'"
              [colorCustom]="true"
              scope="col"
              jdsBiTableHead
              column="type"
            >
              <span>Tipe Data</span>
            </th>
            <th>Judul</th>
            <th [style.width.%]="7">Status</th>
            @if (satudataUser.role_name === 'walidata') {
              <th [style.width.%]="15">Organisasi</th>
            }
            <th [style.width.%]="15">Pengunggah</th>
            <th
              [style.width.%]="14"
              [colorScheme]="'gray'"
              [colorCustom]="true"
              [isSortable]="true"
              [currentSort]="{
                sort: vm.filterSort,
                direction: vm.filterDirection
              }"
              (filterSort)="onSort($event, vm.filterDirection)"
              scope="col"
              jdsBiTableHead
              column="discontinue_submit_date"
            >
              Tanggal Submit
            </th>
            @if (vm.filterStatus !== 'verification') {
              <th
                [style.width.%]="14"
                [colorScheme]="'gray'"
                [colorCustom]="true"
                [isSortable]="true"
                [currentSort]="{
                  sort: vm.filterSort,
                  direction: vm.filterDirection
                }"
                (filterSort)="onSort($event, vm.filterDirection)"
                scope="col"
                jdsBiTableHead
                column="discontinue_approve_date"
              >
                Tanggal Disetujui
              </th>
            }
            <th
              [ngClass]="[jds.textAlign('center')]"
              [style.width.%]="10"
              scope="row"
            >
              Aksi
            </th>
          </tr>
        </thead>
        <tbody>
          @if (vm.listDeskCatalogDiscontinue; as listDesk) {
            @switch (listDesk.status) {
              @case ('loading') {
                <ng-container *ngTemplateOutlet="loading" />
              }

              @case ('success') {
                @if (listDesk.isFetching) {
                  <ng-container *ngTemplateOutlet="loading" />
                } @else if (listDesk.data.list.length > 0) {
                  @for (row of listDesk.data.list; track row.id) {
                    <tr>
                      <td>
                        @switch (row.type) {
                          @case ('dataset') {
                            <span
                              [colorScheme]="'purple'"
                              [variant]="'subtle'"
                              [isRounded]="true"
                              jdsBiBadge
                            >
                              Dataset
                            </span>
                          }
                          @case ('mapset') {
                            <span
                              [colorScheme]="'red'"
                              [variant]="'subtle'"
                              [isRounded]="true"
                              jdsBiBadge
                            >
                              Mapset
                            </span>
                          }
                        }
                      </td>
                      <td>
                        <a
                          [ngClass]="[jds.text('gray900')]"
                          [routerLink]="[
                            '/' + row.type + '/detail',
                            row.type_id
                          ]"
                        >
                          {{ row.name }}
                        </a>
                      </td>
                      <td>
                        @if (row.is_active) {
                          <span [ngClass]="[jds.text(jdsBiColor.green['700'])]">
                            Aktif
                          </span>
                        } @else {
                          <span
                            [ngClass]="[jds.text(jdsBiColor.yellow['700'])]"
                          >
                            Arsip
                          </span>
                        }
                      </td>
                      @if (satudataUser.role_name === 'walidata') {
                        <td>
                          {{ row.nama_skpd_alias }}
                        </td>
                      }
                      <td>{{ row.username }}</td>
                      <td>{{ moment(row.cdate).format('DD/MM/YYYY') }}</td>
                      @if (vm.filterStatus !== 'verification') {
                        <td>
                          {{ moment(row.mdate).format('DD/MM/YYYY') }}
                        </td>
                      }
                      <td [ngClass]="[jds.textAlign('center')]">
                        <div [ngClass]="[jds.d('flex'), jds.gap(4)]">
                          @switch (satudataUser.role_name) {
                            @case ('walidata') {
                              @switch (vm.filterStatus) {
                                @case ('verification') {
                                  <ng-container
                                    [ngTemplateOutlet]="buttonCheck"
                                    [ngTemplateOutletContext]="{
                                      isFull: false,
                                      catalog: row.type,
                                      id: row.type_id
                                    }"
                                  />

                                  <ng-container
                                    [ngTemplateOutlet]="buttonTracking"
                                    [ngTemplateOutletContext]="{
                                      isFull: false,
                                      catalog: row.type,
                                      id: row.type_id
                                    }"
                                  />
                                }
                                @case ('approve') {
                                  <ng-container
                                    [ngTemplateOutlet]="buttonTracking"
                                    [ngTemplateOutletContext]="{
                                      isFull: true,
                                      catalog: row.type,
                                      id: row.type_id
                                    }"
                                  />
                                }
                              }
                            }
                            @case ('opd') {
                              <ng-container
                                [ngTemplateOutlet]="buttonTracking"
                                [ngTemplateOutletContext]="{
                                  isFull: true,
                                  catalog: row.type,
                                  id: row.type_id
                                }"
                              />
                            }
                          }
                        </div>
                      </td>
                    </tr>
                  }
                } @else {
                  <ng-container *ngTemplateOutlet="empty" />
                }
              }

              @case ('error') {
                <ng-container *ngTemplateOutlet="error" />
              }
            }
          }
        </tbody>
      </table>
    </div>

    @if (vm.listDeskCatalogDiscontinue; as listDesk) {
      @if (listDesk.status === 'success') {
        @if (listDesk.data.list.length > 0) {
          <jds-bi-pagination
            [colorScheme]="colorScheme"
            [perPageItems]="perPageItems"
            [pagination]="listDesk.data.pagination"
            [perPage]="vm.filterPerPage"
            [page]="vm.filterCurrentPage"
            (filterPerPage)="onPerPage($event)"
            (filterPage)="onPage($event)"
          />
        }
      }
    }
  </div>

  <app-modal-dataset-tracking [historyData]="vm.historyDataset" />

  <ng-template #loading>
    @for (i of [0, 1, 2, 3, 4, 5, 6, 7, 8, 9]; track $index) {
      <tr>
        @switch (vm.filterStatus) {
          @case ('verification') {
            @for (j of getSkeleton().draft; track $index) {
              <td>
                <ng-container *ngTemplateOutlet="skeleton" />
              </td>
            }
          }
          @case ('approve') {
            @for (j of getSkeleton().approve; track $index) {
              <td>
                <ng-container *ngTemplateOutlet="skeleton" />
              </td>
            }
          }
        }
      </tr>
    }
  </ng-template>

  <ng-template #empty>
    <tr>
      @switch (vm.filterStatus) {
        @case ('verification') {
          <td
            [attr.colspan]="getSkeleton().draft.length"
            [ngClass]="[jds.textAlign('center')]"
          >
            Tidak ada Data.
          </td>
        }
        @case ('approve') {
          <td
            [attr.colspan]="getSkeleton().approve.length"
            [ngClass]="[jds.textAlign('center')]"
          >
            Tidak ada Data.
          </td>
        }
      }
    </tr>
  </ng-template>

  <ng-template #error>
    <tr>
      @switch (vm.filterStatus) {
        @case ('verification') {
          <td
            [attr.colspan]="getSkeleton().draft.length"
            [ngClass]="[jds.textAlign('center')]"
          >
            Terjadi kesalahan.
          </td>
        }
        @case ('approve') {
          <td
            [attr.colspan]="getSkeleton().approve.length"
            [ngClass]="[jds.textAlign('center')]"
          >
            Terjadi kesalahan.
          </td>
        }
      }
    </tr>
  </ng-template>

  <ng-template #skeleton>
    <div class="wrapper-skeleton">
      <ngx-skeleton-loader
        [theme]="{
          width: '80%',
          'border-radius': '0',
          height: '22px',
          'margin-bottom': '0px'
        }"
      />
    </div>
  </ng-template>

  <ng-template
    #buttonCheck
    let-isFull="isFull"
    let-catalog="catalog"
    let-id="id"
  >
    <a
      [ngClass]="[
        jds.button,
        jds.buttonCustom('#42A5F5'),
        jds.text('white'),
        isFull ? jds.w('full') : ''
      ]"
      [routerLink]="['/' + catalog + '/detail', id]"
    >
      Periksa
    </a>
  </ng-template>

  <ng-template
    #buttonTracking
    let-isFull="isFull"
    let-catalog="catalog"
    let-id="id"
  >
    <button
      [ngClass]="[isFull ? jds.w('full') : '']"
      [colorScheme]="'blue'"
      (click)="onTracking(catalog, id)"
      jdsBiButton
    >
      Lacak
    </button>
  </ng-template>
}
